// THE PORTRAIT - a little taste of ISEKAI.

// MAIN FILE: GAMEMAIN & INTRO, MODIFIES, NEW VERBS 
// (put new verbs in a separate iverbs.t ?)


#include <tads.h>
#include "advlite.h"
#undef touchDesc

/* MAIN TODO: (Isekai)
 *
 * -- start the changes in locs/perception, after the arrival of Azuj.
 * 
 * TODO LATER:
 *-- <<inputManager.pauseForMore()>> works as hoped. when feasible,
 *     place the pauses in all those long texts.
 *-- when implementing the disclaimer, put this quote of Crowley:
 *   "Ordinary morality is only for ordinary people"
 *   Whose IMVHO fits the out-of-US border in depiction of sexuality.
 *   (the quote was found in the disclaimer of /Dilemma/ written by a 
 *   "Leonora": due credits ? the quote isn't her, but the idea came from
 *   (her ?) work...)
 */

// GAMEMAIN, Where the curtain is raised.

gameMain: GameMainDef
   allVerbsAllowAll = nil // there's too many bodyparts, decos &.c
   initialPlayerChar = etuye

   showIntro ()
   {
	"You dreamed of being someone else, limping with a painful headache 
towards a large and strange house, with an even stranger tower at its far 
end, looking eerily akin to a mage's tower.\n
Then that someone enters the house and with the brighter light 
inside the house, you discover that person is a woman, thanks to the large 
bosom you glimpse in a brief moment when she lowers her head in her limping 
towards a strange, low-backrest sofa, where she collapses.\n
In your mind you feel the thought: \"<i>Past me... help us... Miyai, Azuj... 
love...</i>\" then she loses consciousness, and you with her.\n
You awake, not in your bed, but on the same strange sofa, in that female 
body you glimpsed; fortunately the headache disappeared, but you're alone, in 
an opposite sex's body, and... somewhere in a strange, exotic, if not even 
alien, place. It looks like you're now having...\b";
	"<b>A taste of Isekai</b>\n
        A 2024 Spring Thing Backgarden entry\n
        by PGdE MMXX-MMXXIV\n
        Release <<versionInfo.version>> (<<versionInfo.serialNum>>)
        \b
<b>[ PLEASE READ THE ABOUT AND THE CREDITS ! ]\n</b>";
}

// 4 test

scoreRankTable = [
[ 0, 'a newcomer'],
[ 20, 'an human in an elf body'],
[ 40, 'a casual museum drifter'],
[ 60, 'an art lover'],
[ 79, 'a connoisseur of fine Art'],
[ 80, 'a connoisseur of fine Art, holding the Last Lousy Point !!']
]
;

versionInfo: GameID
   name='The Portrait' //working title, of course.
   version = '1.01' // urgent bugfix release
   byline = 'PGdE, MMXX - MMXXIV'
   firstPublished = '2024'
   genre = 'isekai, magic, intimistic, excerpt'
// infocom-style serial number :)
   serialNum = static releaseDate.findReplace('-', '', ReplaceAll, 1)


showAbout()
{"<b>ABOUT FOR <i>THE PORTRAIT</i>:</b>\b
first and foremost, this is an excerpt taken from the very beginning of 
<i>Isekai</i>, an interactive story to be released in late 2026, which is 
centered about understanding a new, different world, so, even in this 
excerpt, there's some changing descriptions  in relation to the evolution of 
the PC's understanding of this new environment, so please eXamining around 
often (and this excerpt shows the density of things to examine, and also 
that some of these things have even details which can be examined)\n
Feel free to express your opinion on this excerpt, keeping in mind that few 
details, e.g. these recently introduced in <i>Isekai</i>, aren't precisely 
fully implemented.\n
I have estimated, even prior of the betatest, that getting 100% score is 
<b>NOT</b> easy to be achevied, so this excerpt will offer an option for 
ending the story when a certain number of details of the painting is 
discovered; but I recommend to persist, because there's many little setting, 
lore and backstory tidbits here and there, both in the titular portrait and 
the four rooms around.\n
On these tidbit, I suggest to look up the \"IF Art\" concept, which can be 
helpful in understanding the general narrative. (The painting will be the 
main device used in <i>Isekai</i> for the initial delivering of the general 
setting & background to the player)\n
in the /extras directory you will find three .txt files from IF-Archive, 
containing a description of the concept of If Art and the rules of the first 
two of the now-forgotten \"If Art contest\", I think that reading them will 
help players in understanding my approach to IF narrative.\n
<i>Isekai</i>'s initial puzzle (a very easy one, I hope) is here, but please 
keep in mind that this excerpt is definitively 95% narration (mainly thru 
examining the details of the painting) and 5% puzzles.\n
Thanks in advance for your enjoying/enduring this little excerpt from your 
trustful Imp,\n
Piergiorgio.";
}


showCredit () // very provisional, for obvious reasons
{
"CREDITS SO FAR (not only for this excerpt, but also for <i>Isekai</i>):\b
Marnie \"FemaleDeer\" Parker for introducing in the late 90s the concept of 
puzzleless, story-centered IF, thru his/her \"IF Art\" concept, a major 
factor in the renaissance of IF of the late 90s - early 2000s, and the 
partecipants to the now-forgotten \"IF Art competition\" which has helped 
solidify this innovation in the IF community.\n
Then, my betatesters, Deborah Sherwood and \"Hidnook\", the former also for 
the useful, even surprising, commentary and insights she sent to me.\n
Eric Eve, not only for adv3Lite, but also for his suggestions and multiple 
help, well above and beyond duty.\n
Jim Nelson, Jeff J. McCoskey and \"johnnywz00\" for their suggestions.\n
Joey \"Inventor200\", \"Brett Witty\" and Jim Aikin for the borrowed code 
(due credits also in the source)\n
and... surely other people <b>will</b> be added in due development of 
<i>Isekai</i>...\n";
}
;


// GENERAL MODIFIES

modify Room
// enteringRoom(traveler) { } // keep around 4 now

// let's avoid a strange walking around (and having to keep track of it...)
leavingRoom(traveler) {
  if (skirt.raised) "You lower your skirt prior of walking out.";
   skirt.raised = nil;
}
;

// get rid of the DWIM. Thanks, Jim Nelson !
modify Parser 
  autoSpell = nil
;

// get rid of the misleading "help". Thanks again, Jim Nelson !
modify bodyParts
  initialLocationClass = nil
;

// numerical disamb. Works only up to 20 :( Anyway, thanks, Eric !
modify disambigPreParser
   ordinals = inherited + ['thirteenth', 'fourteenth', 'fifteenth', 
'sixteenth', 'seventeenth', 'eighteenth', 'nineteenth', 'twentieth']
;


// NEW & MODIFIED VERBS

/* TODO later: unhug verbs & synonyms:
 * UNHUG, SEPARATE, REJECT, RELEASE, PUSH AWAY, TURN AWAY, SET FREE, SHOVE
 * (NOT a good thing to do, the answer will point to the rudeness and/or not 
 * a thing Etuye will do..)
 */

//as we say in Italy, "aspetta e guarda" ("wait and watch")

modify grammar predicate (Wait):

    'z' | 'wait' | 'watch'
   :
;

// separating, once and for all, the siamese FEEL and TOUCH 
// DONE, after 5hrs of fighting !!

modify grammar predicate (Feel):

    'feel'  dobjList
    : 
    verbPhrase = 'feel/feeling (what)'
;

DefineTAction(Touch);

VerbRule(Touch)
        'touch' dobjList
        : VerbProduction
        action = Touch
        verbPhrase = 'touch/touching (what)'
        missingQ = 'what do you want to touch'
;

modify Thing
touchDesc = "Touching {the dobj}, {i} don't discover nothing new."
basicExamineTouch() {touchDesc;}

dobjFor(Touch)
    {
      /* Obviously, we have to be able to touch it */
      preCond = [touchObj]
      verify() { }
      action()
      {
        /* show our "touch" description */
        display(&touchDesc);
      }
	}
	;
;

// RAISE
   DefineTAction(Raise);

   VerbRule(Raise)
     ('raise' | 'raise' 'up') singleDobj
        : VerbProduction
        action = Raise
     verbPhrase = 'raise/raising (what)'
     missingQ = 'what do you want to raise'
;

   modify Thing
     dobjFor(Raise)
     {
       verify() 
       {
         illogical('{The dobj} {cannot} be raised.');
       }
     }
;

   modify Wearable
        dobjFor(Raise)
     {
       verify() 
       {
		 if (!isWornBy(gActor))
                illogicalAlready(&notWearingMsg);
            else
              illogical('{The dobj} {cannot} be raised.');
       }
     }
;

// LOWER
   DefineTAction(Lower);

   VerbRule(Lower)
     ('lower' | 'lower' 'down') singleDobj
      : VerbProduction
      action = Lower
     verbPhrase = 'lower/lowering (what)'
     missingQ = 'what do you want to lower'
;

   modify Thing
     dobjFor(Lower)
     {
       verify() 
       {
         illogical('{The dobj} {cannot} be lowered.');
       }
     }
;
   modify Wearable
        dobjFor(Lower)
     {
       verify() 
       {
		 if (!isWornBy(gActor))
                illogicalAlready(&notWearingMsg);
            else
              illogical('{The dobj} {cannot} be raised.');;
       }
     }
;

// TIE
   DefineTAction(Tie);

   VerbRule(Tie)
     ('tie' | 'lace') singleDobj
        : VerbProduction
        action = Tie
     verbPhrase = 'tie/tying (what)'
     missingQ = 'what do you want to tie'
;

   modify Thing
     dobjFor(Tie)
     {
       verify() 
       {
         illogical('{The dobj} {cannot} be tied.');
       }
     }
;

   modify Wearable
        dobjFor(Tie)
     {
       verify() 
       {
		 if (!isWornBy(gActor))
                illogicalAlready(&notWearingMsg);
            else
              illogical('{The dobj} {cannot} be tied.');;
       }
     }
;

// UNTIE
   DefineTAction(Untie);

   VerbRule(Untie)
     ('untie' | 'unlace') singleDobj
        : VerbProduction
        action = Untie
     verbPhrase = 'untie/untying (what)'
     missingQ = 'what do you want to untie'
;

   modify Thing
     dobjFor(Untie)
     {
       verify() 
       {
         illogical('{The dobj} {cannot} be untied.');
       }
     }
;

   modify Wearable
        dobjFor(Untie)
     {
       verify() 
       {
		 if (!isWornBy(gActor))
                illogicalAlready(&notWearingMsg);
            else

              illogical('{The dobj} {cannot} be untied.');
       }
     }
;

// PLAY
DefineTAction(Play);

   VerbRule(Play)
     'play' singleDobj
        : VerbProduction
        action = Play
     verbPhrase = 'play/playing (what)'
     missingQ = 'what do you want to play'
   ;

   modify Thing
     dobjFor(Play)
     {
       verify() 
       {
         illogical('{i} do{es}n\'t know how to play 
                   {that dobj/him}. ');
       }
     }
   ;


// GLOBAL DOERS (all maps & scenes)

// MOVE EARS: for experimentation & convenient templating.
Doer 'move ears'   
    exec(curCmd)
    {
        doInstead(Push, ears);
    }
;
